#!D:/IDE/anaconda3/envs/Microscope_Scan python
# -*- coding: UTF-8 -*-
"""
@FileName：PushTemplateBusiness.py
@Description：
@Author：XSH
@Time：2025/12/2 17:47
@Department：研发部
@Copyright：©2025 乐辰生物
"""
from PyQt5 import Qt
from abc import abstractmethod, abstractclassmethod, abstractstaticmethod
from AppInterfaces.utils                    import *
from AppSettings.utils                      import *
from AppCore.Requests                       import *
from AppInterfaces.Interfaces               import *
from AppCore.Levels                         import *
from AppUtils.utils                         import *
from AppBackEnd.WebBusinessInterface import WebBusinessInterface


class PushTemplateBusiness(Qt.QObject, WebBusinessInterface):
    def __init__(self, manager: WebReaderInterface = None, parent: Qt.QObject = None):
        super(PushTemplateBusiness, self).__init__(parent=parent)
        self.Manager = manager
        self.Initialization("PushTemplateBusiness", self, parent)

    def initWEBAPILevel(self):
        self.Level = WebAPILevel.pushTemplate



    def Done(self, handler: WebClientInterface, **args):
        isWrong: int = RECODE_FAILURE
        from AppSettings.AppStatusSetting import AppStatusSetting, AppStatus
        from AppCore.DBModels import ScanTemplate, Previewsettings, Collectsettings, TrayModel, TrayConfigModel
        try:
            self.Handler = handler
            request: Request = Request.APIInstance(WebAPILevel.pushTemplate)
            request.data = AppStatus.pushtemplate()
            self.WebSendFrame(request.toJson())
        except Exception as e:
            AppUtils.print_Exception(e)

        return
    def WaitDone(self, handler: WebClientInterface, **args) -> int:
        isWrong: int = RECODE_FAILURE
        from AppSettings.AppStatusSetting import AppStatusSetting, AppStatus
        from AppCore.DBModels import ScanTemplate, Previewsettings, Collectsettings, TrayModel, TrayConfigModel
        try:
            self.Handler = handler
            request: Request = Request.APIInstance(WebAPILevel.pushTemplate)
            request.data = AppStatus.pushtemplate()
            isWrong = self.WebSendFrame(request.toJson())
        except Exception as e:
            AppUtils.print_Exception(e)
        return isWrong







